#include "stdafx.h"
#include "apobject.h"

char* shapenames[7] = { "NONAME", "CIRCULAR", "RECTANGULAR", "OCTAGONAL",
					    "ROUNDRECT", "CROSSHAIR", "MOIRE" };

char* typenames[4] = { "NOTYPE", "LINE", "FLASH", "MULTI" }; 

int CApertureObject::nApertureCount = 0;

CApertureObject::CApertureObject(SHAPES shp, TYPES type, int nX, int nY)
{
	m_nXSize = nX;
	m_nYSize = nY;	
	if(m_nXSize == 0 || m_nYSize == 0) {
		m_shape = shp;
		m_type = type;
	}
	else {
		m_shape = shp;
		m_type = type;
	}
	nApertureCount++; 
	nIDThisAperture = nApertureCount;
	
//	TRACE("\nCreating aperture: %d", nApertureCount);
   	return;
}

CApertureObject::CApertureObject(CApertureObject& cao)
{
	m_nXSize = cao.m_nXSize;
	m_nYSize = cao.m_nYSize;	
	m_shape = cao.m_shape;
	m_type = cao.m_type;
	nApertureCount++;
	nIDThisAperture = nApertureCount;
	
//	TRACE("\nCopying aperture: %d", nApertureCount);
   	return;
}

CApertureObject::~CApertureObject()
{
//	TRACE("\nDeleting aperture: %d", nIDThisAperture); 
	nApertureCount--;

} 

BOOL operator == (const CApertureObject& ca1, const CApertureObject& ca2)
{
//	int s = sizeof(CApertureObject);
	if((ca1.m_nXSize != ca2.m_nXSize)
     ||(ca1.m_nYSize != ca2.m_nYSize)
     ||(ca1.m_shape != ca2.m_shape)
     ||(ca1.m_type != ca2.m_type))
		return FALSE;
	else
		return TRUE;
} 

///////////////////////////////////////////////////////////////////////////
// CApertureObList functions 

void CApertureObList::WriteAperture(POSITION pos, int nID, CStdioFile* p_file)
{
	char buffer[100];
	CApertureObject* pAp; 
	
	pAp = (CApertureObject*) GetAt(pos); 
	
	sprintf(buffer, "D%-3d%-11s%4d%4d%3d%6s\n", nID + DCODE_BASE, 
			shapenames[pAp->GetShape()], pAp->GetX(), pAp->GetY(), 
			0, typenames[pAp->GetType()]); 
			
	TRACE("Writing Aperture: %s", buffer);
	p_file->WriteString(buffer);
	
    return;
} 

BOOL CApertureObList::WriteAllApertures(CStdioFile* p_file)
{
	if(p_file == NULL)
	{                    
		if(IsEmpty())    
			return FALSE;
		else
		{
			AfxMessageBox("Error writing aperture table", MB_ICONASTERISK, 0);
			return FALSE;
		}
	}
	else
	{ 
		POSITION pos;
		int nID = 0;
		 
		pos = GetHeadPosition();
		do
		{
			WriteAperture(pos, nID, p_file); 
			nID++;
			GetNext(pos);
		} while(pos);
	} 
	return TRUE; 
} 

BOOL CApertureObList::SearchList(CApertureObject& cao)
{
	// returns TRUE if exists
	POSITION pos;
		 
	for(pos = GetHeadPosition(); pos != NULL; )
	{
		if(*((CApertureObject*)GetNext(pos)) == cao)
			return TRUE; 
	}
	
	return FALSE;   // doesn't already exist
}
