#ifndef APERTURE_LIST
#define APERTURE_LIST

#include "stdafx.h"
#include <afx.h> 

class CApertureObList;

enum SHAPES { NOSHAPE, CIRCULAR, RECTANGULAR, OCTAGONAL, ROUNDRECT, CROSSHAIR, MOIRE };
enum TYPES  { NOTYPE, LINE, FLASH, MULTI }; 

#define DCODE_BASE 11

class CApertureObject : public CObject
{
protected:
	int 		m_nXSize;
	int 		m_nYSize;
	SHAPES 		m_shape;
	TYPES		m_type;
public:
// constructors / destructors
	CApertureObject(SHAPES shp = CIRCULAR, TYPES type = MULTI, int nX = 0, int nY = 0); 
	CApertureObject(CApertureObject& cao);
	~CApertureObject();
// other stuff
	MakeAperture(CString type, char far* data); 
	
public:
	static int 	nApertureCount;
    int			nIDThisAperture;
public:
// 	helpers
	int			GetX()    	const 	{ return m_nXSize; }
	int			GetY()    	const 	{ return m_nYSize; }
	SHAPES		GetShape() 	const 	{ return m_shape; } 
	TYPES			GetType()   const 	{ return m_type; }
//  friend functions
	friend BOOL operator == (const CApertureObject& ca1, const CApertureObject& ca2);
}; 

class CApertureObList : public CObList
{ 
public:
	BOOL SearchList(CApertureObject& cao); // return true if exixts
	void WriteAperture(POSITION pos, int nID, CStdioFile* p_file); 
	BOOL WriteAllApertures(CStdioFile* p_file);
};

#endif // APERTURE_LIST