// dcodedoc.h : interface of the CDcodeDoc class
//
/////////////////////////////////////////////////////////////////////////////
#include "apobject.h"

class CDcodeDoc : public CDocument
{
protected: // create from serialization only
	CDcodeDoc();
	DECLARE_DYNCREATE(CDcodeDoc)

// Attributes
public:
	CStdioFile* 		m_pInputFile; 
	CString				m_sInputFileName;
	CStdioFile*			m_pOutputFile; 
	CApertureObList* 	m_pApList;
	int 				m_nPGEnlg;
	int 				m_nSMEnlg;
	int 				m_nPMEnlg; 
	BOOL  				m_bFills;
// Operations
public:  
	int ScanPCBFile(void);
	void TidyUp(CStdioFile*& pFile);

// Implementation
public:
	virtual ~CDcodeDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual BOOL OnNewDocument(); 
	BOOL		LoadStdApertures();

// Generated message map functions
protected:
	//{{AFX_MSG(CDcodeDoc)
	afx_msg void OnAddAper();
	afx_msg void OnMakeTable();
	afx_msg void OnFileSave();
	afx_msg void OnFileOpen();
	afx_msg void OnUpdateFileSave(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMakeTable(CCmdUI* pCmdUI);
	afx_msg void OnSetEnlg();
	afx_msg void OnClearTable();
	afx_msg void OnUpdateClearTable(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
